/***************************************************************************
                          reko.h  -  description
                             -------------------
    begin                : Sun Aug 25 2002
    copyright            : (C) 2002 by kdereko@yahoo.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef REKO_H
#define REKO_H

#include <qstring.h>

typedef unsigned char UBYTE ;
typedef unsigned short UWORD ;
typedef unsigned long ULONG ;

#pragma pack(1)

struct RekoHeader /* REKO file header */
{
  UBYTE rh_ID[4];
  ULONG rh_BodySize;	/* Motorola big endian format */
  ULONG rh_CardSize;	/* Motorola big endian format */
  UWORD rh_Height;	/* Motorola big endian format */
  UWORD rh_Width;	/* Motorola big endian format */
  ULONG rh_ModeID;	/* Motorola big endian format */
  UBYTE rh_Depth;
  UBYTE rh_CardsCnt;
};

struct Palette
{
  UBYTE r,g,b;
};
/*__attribute__ ((__packed__));*/

#define swapw(x) ( (((x)>>8)&0xff) | ( ((x)<<8)&0xff00) )
#define swapl(x) ( (((x)>>24)&0xff) | ( ( (x)>>8)&0x0000ff00 ) | (((x)<<8)&0x00ff0000) | (((x)<<24)&0xff000000) )


class Reko {
public: 
	Reko();
	~Reko();
  /** No descriptions */
  bool convert(QString inname,QString outname,int distort);
  /** No descriptions */
  bool indexfile(QString filename, QString name);
  /** No descriptions */
  bool makedir(QString name);
protected: // Protected methods
  /** No descriptions */
  int getBit (char *data, unsigned long index);
  /** No descriptions */
  void assign_cards(int *map, int reko,int kde);
};

#endif
